package soapui.demo;

import groovy.sql.Sql;
import java.text.DateFormat;
import groovy.xml.MarkupBuilder
import org.custommonkey.xmlunit.*

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.sql.SQLException;
import oracle.jdbc.driver.OracleTypes;
import org.hsqldb.jdbcDriver;
import org.hsqldb.jdbc.jdbcBlob;

import org.xml.sax.SAXException;
import javax.xml.transform.Source;
import javax.xml.validation.SchemaFactory;
import javax.xml.transform.stream.StreamSource;

import org.apache.activemq.broker.BrokerService;
import org.apache.activemq.ActiveMQConnectionFactory;
import org.apache.commons.codec.binary.Base64

import javax.jms.*;
import javax.naming.*;

class Open_ePRIOR
{
    def sql;
    def log;
    def context;
    def testRunner;
    def jmsConnection;
    def jmsSession;
    def jmsQueue;
    def msgAgrId;
    def msgSupId;
    def environment;

    Open_ePRIOR(log, testRunner, context = null) 
    { 
        sql = null;
        jmsConnection = null;
        jmsSession = null;
        jmsQueue = null;
        this.log = log;
        this.testRunner = testRunner;
        this.context = context;
        msgAgrId = '0';
        msgSupId = '0';
        environment = TestEnvironment.NON_EXISTING;
    }
 
  
    def openConnection(TestEnvironment testEnvironment, supplierID = '-1', agreementID = '-1')
    {
        switch (testEnvironment)
        {
        case TestEnvironment.TEST:
            sql = Sql.newInstance("jdbc:oracle:thin:@devora4.cc.cec.eu.int:1586:PRIOCOMT", "prior_user", "tatpromwel1\$", "oracle.jdbc.driver.OracleDriver");
            msgAgrId = '5';
            msgSupId = '5';
            environment = TestEnvironment.TEST;
            break;
        case TestEnvironment.OPEN_EPRIOR_TEST:
            sql = Sql.newInstance("jdbc:hsqldb:hsql://d02di1010873:1701", "sa","", "org.hsqldb.jdbcDriver");
            msgAgrId = '0';
            environment = TestEnvironment.OPEN_EPRIOR_TEST;
            break;
        case TestEnvironment.DEVELOPMENT:
            sql = Sql.newInstance("jdbc:oracle:thin:@devora4.cc.cec.eu.int:1586:PRIOCOMD", "prior_user", "tatpromwel1\$", "oracle.jdbc.driver.OracleDriver");
            environment = TestEnvironment.DEVELOPMENT;
            msgAgrId = '23';
	    msgSupId = '5';
            break;
        case TestEnvironment.ACCEPTANCE:
            sql = Sql.newInstance("jdbc:oracle:thin:@oraprod7.cc.cec.eu.int:1577:PRIOCOMA", "prior_user", "sdlk90234!", "oracle.jdbc.driver.OracleDriver");
            environment = TestEnvironment.ACCEPTANCE;
            msgAgrId = '5';
            break;
        case TestEnvironment.PROD:
            sql = Sql.newInstance("jdbc:oracle:thin:@oraprod7.cc.cec.eu.int:1577:PRIOCOMP", "prior_user", "sdlk90234!", "oracle.jdbc.driver.OracleDriver");
            environment = TestEnvironment.PROD;
            break;
        default:
            log.error "TestEnvironment unknown";        
        }
        if( supplierID != '-1' )
        {
            msgSupId = supplierID;
        }
        if( agreementID != '-1' )
        {
            msgAgrId = agreementID;
        }
    }
   
    def closeConnection()
    {
        sql.connection.close();
        sql = null;
    }
 
    def openSession(TestEnvironment testEnvironment, JmsQueues jmsQueues = JmsQueues.BO_TO_EPRIOR)
    {
        String url = null;
        switch (testEnvironment)
        {
        case TestEnvironment.TEST:
            if (jmsQueues == JmsQueues.BO_TO_EPRIOR)
                url = "t3://epriord.cc.cec.eu.int:17071";
            else
                url = "t3://wltdig02.cc.cec.eu.int:2101";
            break;
        case TestEnvironment.DEVELOPMENT:
            url = "t3://epriord.cc.cec.eu.int:7071";
            break;
        case TestEnvironment.OPEN_EPRIOR_TEST:
		    url = "t3://d02di1010873:1701";
            break;
        case TestEnvironment.ACCEPTANCE:
        case TestEnvironment.PROD:
        default:
            log.error "TestEnvironment unknown";
            testRunner.fail("TestEnvironment unknown");
        }
        
        Hashtable  aMap = new Hashtable ();
        aMap.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");

	aMap.put(Context.PROVIDER_URL, "158.168.153.36");
        Context ctx = new InitialContext(aMap);		
        ConnectionFactory cf = null;
        
        if (jmsQueues == JmsQueues.BO_TO_EPRIOR)
            cf = (ConnectionFactory) ctx.lookup("ConnectionFactory");
        else
            cf = (ConnectionFactory) ctx.lookup("jms/digit.interfaces.premises.ConnectionFactory");
        
        switch (jmsQueues)
        {
        case JmsQueues.BO_TO_EPRIOR:
            jmsQueue = (Queue) ctx.lookup("queue/BOToOpenEPriorQueue");
            jmsConnection = cf.createConnection();
            jmsSession = jmsConnection.createSession(false, Session.AUTO_ACKNOWLEDGE);   
            break;
        case JmsQueues.EPRIOR_TO_EREQUESTBO:
            jmsQueue = (Queue) ctx.lookup("jms/digit.interfaces.erequest.in");
            jmsConnection = cf.createConnection();
            jmsSession = jmsConnection.createSession(false, Session.DUPS_OK_ACKNOWLEDGE);   
            break;
        default:
            log.error "JmsQueue unknown";
            testRunner.fail("JmsQueue unknown");
        }
    }
 
    def closeSession()
    {
        jmsQueue = null;
        jmsSession.close();
        jmsSession = null;
        jmsConnection.close();
        jmsConnection = null;
    }
    
    def sendJmsTxtMessage( String msgUser, String msgCustomer, String msgSupplier, String jmsCorrelationId, String msgSource )
    {
        MessageProducer producer = jmsSession.createProducer(jmsQueue);

        def xml = context.expand( msgSource );

        TextMessage txtMsg = jmsSession.createTextMessage();
        txtMsg.setStringProperty("MSG_USER", msgUser);
        txtMsg.setStringProperty("MSG_CUSTOMER", msgCustomer);
        txtMsg.setStringProperty("MSG_SUPPLIER", msgSupplier);
        //txtMsg.setStringProperty("MSG_TYPE","RequestForQuotation");
        txtMsg.setJMSCorrelationID(jmsCorrelationId);

        txtMsg.setText(xml);
        producer.send(txtMsg);
        //jmsSession.commit();
        
    }
    
    def browseJmsQueue(String jmsCorrelationId)
    {
        QueueBrowser br = jmsSession.createBrowser(jmsQueue);

        Enumeration e = br.getEnumeration();
        int count =0;
        while (e.hasMoreElements())
        {
            Object o = e.nextElement();
            if (o instanceof TextMessage)
            {
                TextMessage msg = (TextMessage)o;
                //if(msg.getJMSCorrelationID() == jmsCorrelationId)
                    log.info(++count+ ", Msg content : " +msg.getText() +", received:"+new Date(msg.getJMSTimestamp())+", type:" + msg.getStringProperty("MSG_TYPE")+", correlation id:"+msg.getJMSCorrelationID());
            }
            else
            {
                Message msg =(Message)o;
                log.info(msg +", "+new Date(msg.getJMSTimestamp()));
            }
        }        
    }
    
    def cleanDatabase( TestEnvironment testEnvironment, DatabaseUser databaseUser )
    {
        def driver = oracle.jdbc.driver.OracleDriver;

        Connection conn = null;
        Statement stmt = null;

        switch (testEnvironment)
        {
        case TestEnvironment.TEST:
            msgAgrId = '5';
            conn = DriverManager.getConnection('jdbc:oracle:thin:@devora4.cc.cec.eu.int:1586:PRIOCOMT','prior_user','tatpromwel1$');
            break;
        case TestEnvironment.OPEN_EPRIOR_TEST:
            msgAgrId = '0';
            Class.forName("org.hsqldb.jdbcDriver");
	        conn = DriverManager.getConnection('jdbc:hsqldb:hsql://d02di1010873:1701','sa','');
            break;
        case TestEnvironment.DEVELOPMENT:
            msgAgrId = '5';
            conn = DriverManager.getConnection('jdbc:oracle:thin:@devora4.cc.cec.eu.int:1586:PRIOCOMD','prior_user','tatpromwel1$');
            break;
        case TestEnvironment.ACCEPTANCE:
            msgAgrId = '5';
            conn = DriverManager.getConnection('jdbc:oracle:thin:@oraprod7.cc.cec.eu.int:1577:PRIOCOMA','prior_user','sdlk90234!');
            break;
        case TestEnvironment.PROD:
            conn = DriverManager.getConnection('jdbc:oracle:thin:@oraprod7.cc.cec.eu.int:1577:PRIOCOMP','prior_user','sdlk90234!');
            break;
        default:
            log.error "TestEnvironment unknown";        
        }

        stmt = conn.createStatement();
        
        try
        {
            switch( databaseUser )
            {
                case DatabaseUser.EANTST0:
                
                    def numRows = stmt.executeUpdate("DELETE FROM EPR_TB_EVENT WHERE EVT_MSG_ID IN ( SELECT MSG_ID FROM EPR_TB_MESSAGE WHERE ( ( MSG_AGR_ID = ${msgAgrId} ) OR ( MSG_SUP_ID = ${msgAgrId} ) ) )");
	                log.info numRows + " rows deleted from EPR_TB_EVENT table";
                
                    def hasMoreRows = true;

                    while(hasMoreRows)
                    {
                        numRows = stmt.executeUpdate("DELETE FROM EPR_TB_MESSAGE WHERE ( MSG_AGR_ID = ${msgAgrId}  OR  MSG_SUP_ID = ${msgAgrId} ) AND MSG_ID NOT IN (SELECT MSG_MSG_ID FROM EPR_TB_MESSAGE WHERE MSG_MSG_ID IS NOT NULL)");
                        log.info numRows + " rows deleted from EPR_TB_MESSAGE table(with msg_msg_id not null)";

                        hasMoreRows = numRows > 0;	
                    }

                    numRows = stmt.executeUpdate("DELETE FROM EPR_TB_MESSAGE WHERE ( ( MSG_AGR_ID = ${msgAgrId}  OR  MSG_SUP_ID = ${msgAgrId} ) AND MSG_ID NOT IN (SELECT MSG_MSG_ID FROM EPR_TB_MESSAGE WHERE MSG_MSG_ID IS NOT NULL))");
                    log.info numRows + " rows deleted from EPR_TB_MESSAGE table";

                    numRows = stmt.executeUpdate("DELETE FROM EPR_TB_OBJECT WHERE ( ( EPR_TB_OBJECT.OBJ_OBJ_ID IS NOT NULL ) AND ( NOT EXISTS (SELECT * FROM EPR_TB_MESSAGE WHERE ( (EPR_TB_MESSAGE.MSG_OBJ_ID = EPR_TB_OBJECT.OBJ_ID ) ) ) ) )");
                    log.info numRows + " rows deleted from EPR_TB_OBJECT table in pass 1";
                    numRows = stmt.executeUpdate("DELETE FROM EPR_TB_OBJECT WHERE (NOT EXISTS (SELECT * FROM  EPR_TB_MESSAGE WHERE EPR_TB_MESSAGE.MSG_OBJ_ID = EPR_TB_OBJECT.OBJ_ID)) AND (NOT EXISTS (SELECT * FROM EPR_TB_OBJECT TAB2 WHERE EPR_TB_OBJECT.OBJ_ID = TAB2.OBJ_OBJ_ID))");
                    log.info numRows + " rows deleted from EPR_TB_OBJECT table in pass 2";

                    stmt.executeUpdate("DELETE FROM EPR_TB_MSG_REPOSITORY WHERE ( REP_AGR_ID = ${msgAgrId} )");
                    log.info numRows + " rows deleted from EPR_TB_MSG_REPOSITORY table";
                    
                    numRows = stmt.executeUpdate("DELETE FROM EPR_TB_BINARY WHERE ( ( NOT EXISTS (SELECT * FROM EPR_TB_MESSAGE WHERE ( EPR_TB_MESSAGE.MSG_BIN_ID = EPR_TB_BINARY.BIN_ID ) ) ) AND ( NOT EXISTS (SELECT * FROM EPR_TB_MSG_REPOSITORY WHERE ( EPR_TB_MSG_REPOSITORY.REP_BIN_ID = EPR_TB_BINARY.BIN_ID ) ) ) )");
                    log.info numRows + " rows deleted from EPR_TB_BINARY table";
                    break;
                case DatabaseUser.EANCATSUP0:
                    def numRows = stmt.executeUpdate("DELETE FROM PRIOR_USER.EPR_TB_EVENT WHERE EVT_MSG_ID IN ( SELECT MSG_ID FROM EPR_TB_MESSAGE WHERE ( ( MSG_AGR_ID = '25' ) OR ( MSG_SUP_ID = '19' ) ) )");
                    log.info numRows + " rows deleted from EPR_TB_EVENT table";

                    numRows = stmt.executeUpdate("DELETE FROM EPR_TB_MESSAGE WHERE ( ( MSG_AGR_ID = '25' ) OR ( MSG_SUP_ID = '19' ) )");
                    log.info numRows + " rows deleted from EPR_TB_MESSAGE table";

                    numRows = stmt.executeUpdate("DELETE FROM PRIOR_USER.EPR_TB_OBJECT WHERE ( ( PRIOR_USER.EPR_TB_OBJECT.OBJ_OBJ_ID IS NOT NULL ) AND ( NOT EXISTS (SELECT * FROM EPR_TB_MESSAGE WHERE ( (EPR_TB_MESSAGE.MSG_OBJ_ID = PRIOR_USER.EPR_TB_OBJECT.OBJ_ID ) ) ) ) )");
                    log.info numRows + " rows deleted from EPR_TB_OBJECT table in pass 1";
                    numRows = stmt.executeUpdate("DELETE FROM PRIOR_USER.EPR_TB_OBJECT WHERE ( ( NOT EXISTS (SELECT * FROM EPR_TB_MESSAGE WHERE ( EPR_TB_MESSAGE.MSG_OBJ_ID = PRIOR_USER.EPR_TB_OBJECT.OBJ_ID ) ) ) AND ( NOT EXISTS (SELECT * FROM (PRIOR_USER.EPR_TB_OBJECT) TAB2 WHERE ( PRIOR_USER.EPR_TB_OBJECT.OBJ_ID = TAB2.OBJ_OBJ_ID ) ) ) )");
                    log.info numRows + " rows deleted from EPR_TB_OBJECT table in pass 2";

                    stmt.executeUpdate("DELETE FROM PRIOR_USER.EPR_TB_MSG_REPOSITORY WHERE ( REP_AGR_ID = '25' )");
                    log.info numRows + " rows deleted from EPR_TB_MSG_REPOSITORY table";
                    
                    numRows = stmt.executeUpdate("DELETE FROM PRIOR_USER.EPR_TB_BINARY WHERE ( ( NOT EXISTS (SELECT * FROM EPR_TB_MESSAGE WHERE ( EPR_TB_MESSAGE.MSG_BIN_ID = PRIOR_USER.EPR_TB_BINARY.BIN_ID ) ) ) AND ( NOT EXISTS (SELECT * FROM PRIOR_USER.EPR_TB_MSG_REPOSITORY WHERE ( PRIOR_USER.EPR_TB_MSG_REPOSITORY.REP_BIN_ID = PRIOR_USER.EPR_TB_BINARY.BIN_ID ) ) ) )");
                    log.info numRows + " rows deleted from EPR_TB_BINARY table";
                    break;
                default:
                    log.error "databaseUser unknown";
            }
        }
        catch (SQLException ex)
        {
            log.info "SQLException occured: " + ex;
        }
        finally 
        {
            if (stmt)
            {
                stmt.close();
            }
            if (conn)
            {
                conn.commit();
                conn.close();
            }
            log.info "resources released";
        }
    }
 
    def String findRequestId(MessageType messageType, String testCaseName, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;

        def node = null;
        def id = -1;

        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }

        switch (messageType)
        {
            case MessageType.INVOICE:
                id = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:ID"].text();
                break;
            case MessageType.CREDITNOTE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:ID"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:ID"].text();
                break;
            case MessageType.WILLINGNESS:
                id = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:ID"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:ID"].text();
                break;
            case MessageType.ADHOCS2C:
                id = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:ID"].text();
                break;
            case MessageType.QUOTATION:
                id = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:ID"].text();
                break;
            case MessageType.PROPOSAL:
                id = node["SOAP-ENV:Body"]["ec:SubmitProposalRequest"]["ec:Proposal"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderChangeRequest"]["ec:OrderChange"]["cbc:ID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ADHOCC2S:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDER:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERCANCELLATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                id = node["cbc:ID"].text();
                break;
            case MessageType.CATALOGUE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:ID"].text() + "::" + node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:VersionID"].text();
                break;
            default:
                log.error "messageType unknown";
        }
        return id;
    }
    
    def String findRequestDate(MessageType messageType, String testCaseName, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
        
        def date = -1;
        def node = null;
        
        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                date = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:IssueDate"].text();
                break;
            case MessageType.CREDITNOTE:
                date = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:IssueDate"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                date = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:IssueDate"].text();
                break;
            case MessageType.WILLINGNESS:
                date = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:IssueDate"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                date = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:IssueDate"].text();
                break;
            case MessageType.ADHOCS2C:
                date = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:IssueDate"].text();
                break;
            case MessageType.QUOTATION:
                date = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:IssueDate"].text();
                break;
            case MessageType.PROPOSAL:
                date = node["SOAP-ENV:Body"]["ec:SubmitProposalRequest"]["ec:Proposal"]["cbc:IssueDate"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                date = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:IssueDate"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                date = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:IssueDate"].text();
                break;
            case MessageType.ORDERCHANGE:
                date = node["SOAP-ENV:Body"]["ec:SubmitOrderChangeRequest"]["ec:OrderChange"]["cbc:IssueDate"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.ADHOCC2S:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.ORDER:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.ORDERCANCELLATION:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                date = node["cbc:IssueDate"].text();
                break;
            case MessageType.CATALOGUE:
                date = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:IssueDate"].text();
                break;
            default:
                log.error "messageType unknown";
        }
        
        return date;
    }
    
    def String findRequestCustomerId(MessageType messageType, String testCaseName, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;

        def node = null;
        def id = -1;
        
        if(JMS)
        {
            id = "EAN100";
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
            case MessageType.CREDITNOTE:
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
            case MessageType.WILLINGNESS:
            case MessageType.ACKNOWLEDGEMENT:
            case MessageType.CATALOGUE:
            case MessageType.ADHOCS2C:
            case MessageType.QUOTATION:
            case MessageType.PROPOSAL:
            case MessageType.ORDERRESPONSESIMPLE:
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Header"]["ec:AuthorisationHeader"]["eccbc:CustomerID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                break;
            case MessageType.PROPOSALREQUEST:
                break;
            case MessageType.QUOTATIONREQUEST:
                break;
            case MessageType.ADHOCC2S:
                break;
            case MessageType.ORDER:
                break;
            case MessageType.ORDERCANCELLATION:
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                break;
            default:
                log.error "messageType unknown";
        }
        return id;
    }
    
    def String findRequestSupplierId(MessageType messageType, String testCaseName, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
            
        def node = null;
        def id = -1;
        
        if(JMS)
        {
            id = "EANTST0";
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
            case MessageType.CREDITNOTE:
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
            case MessageType.WILLINGNESS:
            case MessageType.ACKNOWLEDGEMENT:
            case MessageType.CATALOGUE:
            case MessageType.ADHOCS2C:
            case MessageType.QUOTATION:
            case MessageType.PROPOSAL:
            case MessageType.ORDERRESPONSESIMPLE:
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Header"]["ec:AuthorisationHeader"]["eccbc:SupplierID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                break;
            case MessageType.PROPOSALREQUEST:
                break;
            case MessageType.QUOTATIONREQUEST:
                break;
            case MessageType.ADHOCC2S:
                break;
            case MessageType.ORDER:
                break;
            case MessageType.ORDERCANCELLATION:
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                break;
            default:
                log.error "messageType unknown";
        }
        return id;
    }
 
    def String findParentObjId(MessageType messageType, String testCaseName, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
        
        def id = -1;
        def objId = -1;
        def node = null;
        
        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                id = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:ID"].text();
                break;
            case MessageType.CREDITNOTE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:ID"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:ID"].text();
                break;
            case MessageType.WILLINGNESS:
                id = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:ID"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:ID"].text();
                break;
            case MessageType.ADHOCS2C:
                id = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:ID"].text();
                break;
            case MessageType.QUOTATION:
                id = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:ID"].text();
                break;
            case MessageType.PROPOSAL:
                id = node["SOAP-ENV:Body"]["ec:SubmitProposalRequest"]["ec:Proposal"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderChangeRequest"]["ec:OrderChange"]["cbc:ID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ADHOCC2S:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDER:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERCANCELLATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                id = node["cbc:ID"].text();
                break;
            case MessageType.CATALOGUE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:ID"].text() + "::" + node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:VersionID"].text();
                break;
            default:
                log.error "messageType unknown";
        }

        if(id != -1)        
        {
            sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                objId = it.MSG_ID;
            }
        }
        
        return objId;
    }
 
    def String findMsgObjId(MessageType messageType, String testCaseName, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
        
        def id = -1;
        def objId = -1;
        def node = null;
        
        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                id = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:ID"].text();
                break;
            case MessageType.CREDITNOTE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:ID"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:ID"].text();
                break;
            case MessageType.WILLINGNESS:
                id = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:ID"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:ID"].text();
                break;
            case MessageType.ADHOCS2C:
                id = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:ID"].text();
                break;
            case MessageType.QUOTATION:
                id = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:ID"].text();
                break;
            case MessageType.PROPOSAL:
                id = node["SOAP-ENV:Body"]["ec:SubmitProposalRequest"]["ec:Proposal"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderChangeRequest"]["ec:OrderChange"]["cbc:ID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ADHOCC2S:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDER:
                id = node["cbc:ID"].text();
				break;
            case MessageType.ORDERCANCELLATION:
                id = node["cbc:ID"].text();
				break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                id = node["cbc:ID"].text();
                break;
            case MessageType.CATALOGUE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:ID"].text() + "::" + node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:VersionID"].text();
                break;
            default:
                log.error "messageType unknown";
        }

        if(id != -1)        
        {
            sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                objId = it.MSG_OBJ_ID;
            }
        }
        
        return objId;
    }
    
    def String findChildMsgId(MessageType messageType, String testCaseName, MessageType childType, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
        
        def id = -1;
        def objId = -1;
        def childMsgId = -1;
        def node = null;
        
        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {        
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                id = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:ID"].text();
                break;
            case MessageType.CREDITNOTE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:ID"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:ID"].text();
                break;
            case MessageType.WILLINGNESS:
                id = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:ID"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:ID"].text();
                break;
            case MessageType.ADHOCS2C:
                id = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:ID"].text();
                break;
            case MessageType.QUOTATION:
                id = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:ID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ADHOCC2S:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDER:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERCANCELLATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                id = node["cbc:ID"].text();
                break;
            case MessageType.CATALOGUE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:ID"].text() + "::" + node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:VersionID"].text();
                break;
        }

        if(id != -1)        
        {
            sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                objId = it.MSG_ID;
            }
            if( objId != -1 )
            {
                if( childType != MessageType.APPLICATIONRESPONSE )
                {
                    sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_MSG_ID = ${objId}) AND (MSG_MST_CD = '" + childType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
                    { 
                        childMsgId = it.MSG_OBJ_ID;
                    }
                }
                else
                {
                    sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( MSG_MSG_ID = ${objId} )")
                    { 
                        childMsgId = it.MSG_OBJ_ID;
                    }
                }
            }
        }
	  else
        {
            sql.eachRow("SELECT MAX(MSG_OBJ_ID) maxMsgId FROM EPR_TB_MESSAGE")
            {
                childMsgId = it.maxMsgId;
            }
        }

        
        return childMsgId;
    }
    
    def String findChildMsgMsgId(MessageType messageType, String testCaseName, MessageType childType, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
        
        def id = -1;
        def objId = -1;
        def childMsgId = -1;
        def node = null;
        
        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                id = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:ID"].text();
                break;
            case MessageType.CREDITNOTE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:ID"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:ID"].text();
                break;
            case MessageType.WILLINGNESS:
                id = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:ID"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:ID"].text();
                break;
            case MessageType.ADHOCS2C:
                id = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:ID"].text();
                break;
            case MessageType.QUOTATION:
                id = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:ID"].text();
                break;
            case MessageType.PROPOSAL:
                id = node["SOAP-ENV:Body"]["ec:SubmitProposalRequest"]["ec:Proposal"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderChangeRequest"]["ec:OrderChange"]["cbc:ID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ADHOCC2S:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDER:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERCANCELLATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                id = node["cbc:ID"].text();
                break;
            case MessageType.CATALOGUE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:ID"].text() + "::" + node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:VersionID"].text();
                break;
        }

        if(id != -1)        
        {
            sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                objId = it.MSG_ID;
            }
            if( objId != -1 )
            {
                if( childType != MessageType.APPLICATIONRESPONSE )
                {
                    sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_MSG_ID = ${objId}) AND (MSG_MST_CD = '" + childType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
                    { 
                        childMsgId = it.MSG_MSG_ID;
                    }
                }
                else
                {
                    sql.eachRow("SELECT MIN(MSG_ID) minMsgId FROM EPR_TB_MESSAGE WHERE ( MSG_MSG_ID = ${objId} )")
                    { 
                        childMsgId = it.minMsgId;
                    }
                }
            }
        }
        else
        {
            sql.eachRow("SELECT MAX(MSG_ID) maxMsgId FROM EPR_TB_MESSAGE WHERE ( MSG_SUP_ID = ${msgSupId} )")
            {
                childMsgId = it.maxMsgId;
            }
        }
        
        if( ( childMsgId == -1 ) || ( childMsgId == null ) )
            testRunner.fail("Child message not found");

        return childMsgId;
    }
    
    def String findChildMsgDocumentId(MessageType messageType, String testCaseName, MessageType childType, boolean JMS = false)
    {
        if(testCaseName == null)
            return -1;
        
        def id = -1;
        def objId = -1;
        def childMsgId = -1;
        def node = null;
        
        if(JMS)
        {
            def text = context.expand( testCaseName );
            node = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {        
            def request = testRunner.testCase.getTestStepByName(testCaseName);
            def property = request.getProperty( "request" );
            node = new groovy.util.XmlParser(false,false).parseText(property.value);
        }
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                id = node["SOAP-ENV:Body"]["ec:SubmitInvoiceRequest"]["ec:Invoice"]["cbc:ID"].text();
                break;
            case MessageType.CREDITNOTE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCreditNoteRequest"]["ec:CreditNote"]["cbc:ID"].text();
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAttachedDocumentRequest"]["ec:AttachedDocument"]["cbc:ID"].text();
                break;
            case MessageType.WILLINGNESS:
                id = node["SOAP-ENV:Body"]["ec:SubmitWillingnessRequest"]["ec:Willingness"]["cbc:ID"].text();
                break;
            case MessageType.ACKNOWLEDGEMENT:
                id = node["SOAP-ENV:Body"]["ec:SubmitAcknowledgementRequest"]["ec:Acknowledgement"]["cbc:ID"].text();
                break;
            case MessageType.ADHOCS2C:
                id = node["SOAP-ENV:Body"]["ec:SubmitAdhocS2CRequest"]["ec:AdhocS2C"]["cbc:ID"].text();
                break;
            case MessageType.QUOTATION:
                id = node["SOAP-ENV:Body"]["ec:SubmitQuotationRequest"]["ec:Quotation"]["cbc:ID"].text();
                break;
            case MessageType.PROPOSAL:
                id = node["SOAP-ENV:Body"]["ec:SubmitProposalRequest"]["ec:Proposal"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderResponseSimpleRequest"]["ec:OrderResponseSimple"]["cbc:ID"].text();
                break;
            case MessageType.ORDERCHANGE:
                id = node["SOAP-ENV:Body"]["ec:SubmitOrderChangeRequest"]["ec:OrderChange"]["cbc:ID"].text();
                break;
            case MessageType.REQUESTFORQUOTATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.PROPOSALREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.QUOTATIONREQUEST:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ADHOCC2S:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDER:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERCANCELLATION:
                id = node["cbc:ID"].text();
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                id = node["cbc:ID"].text();
                break;
            case MessageType.CATALOGUE:
                id = node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:ID"].text() + "::" + node["SOAP-ENV:Body"]["ec:SubmitCatalogueRequest"]["ec:Catalogue"]["cbc:VersionID"].text();
                break;
        }

        if(id != -1)        
        {
            sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                objId = it.MSG_ID;
            }
            if( objId != -1 )
            {
                if( childType != MessageType.APPLICATIONRESPONSE )
                {
                    sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_MSG_ID = ${objId}) AND (MSG_MST_CD = '" + childType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
                    { 
                        childMsgId = it.MSG_DOCUMENTID;
                    }
                }
                else
                {
                    sql.eachRow("SELECT MIN(MSG_DOCUMENTID) minDocId FROM EPR_TB_MESSAGE WHERE ( MSG_MSG_ID = ${objId} )")
                    { 
                        childMsgId = it.minDocId;
                    }
                }
            }
        }
        else
        {
            sql.eachRow("SELECT MSG_DOCUMENTID maxDocId FROM EPR_TB_MESSAGE t1 WHERE MSG_ID = ( SELECT MAX(MSG_ID) maxMsgId FROM EPR_TB_MESSAGE t2 )")
            {
                childMsgId = it.maxDocId;
            }
        }
        
        if( ( childMsgId == -1 ) || ( childMsgId == null ) )
            testRunner.fail("Child message not found");

        return childMsgId;
    }
    
    def findMessage(MessageType messageType, MessageState messageState, String parentId = "-1", String messageName="Request", boolean checkHumanReadableContent = false)
    {
        def id = findRequestId(messageType, messageName);
        def issueDate = findRequestDate(messageType, messageName);
        findMessageById(messageType, messageState, parentId, id, issueDate, checkHumanReadableContent);
    }
    
    def findMessageJMS(MessageType messageType, MessageState messageState, String parentId = "-1", String messageName='${Request#xml}', boolean checkHumanReadableContent = false)
    {
        def id = findRequestId(messageType, messageName, true);
        def issueDate = findRequestDate(messageType, messageName, true);
        findMessageById(messageType, messageState, parentId, id, issueDate, checkHumanReadableContent);
    }
    
    def findMessageById(MessageType messageType, MessageState messageState, String parentId = "-1", String id, String issueDate, boolean checkHumanReadableContent)
    {
        if (messageState == MessageState.NON_EXISTING)
        {
            def numResults = 0;
       
            sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                numResults++;
            }
            
            if(numResults != 0)
            {
                log.error "Message found while it should not exist in the system" + numResults;
                testRunner.fail("Message found while it should not exist in the system");
            }      
        }   
            
        else
        {   
            def now = new Date();
            def receiptDate = String.format('%tY-%<tm-%<td', now);

            def numResults = 0;
            def objId = -1;
		
		log.info "ID: " + id;
		log.info "MessageType: " + messageType.toString();
		log.info "SUP_ID: " + msgSupId;
		sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
            { 
                numResults++;

                // ID an type of the document are verified by making the SQL query itself
        
                objId = it.MSG_OBJ_ID; // Will be used in a new query for the object table

                if (String.format('%tY-%<tm-%<td', (it.MSG_ISSUE_DT)) != issueDate)
                    testRunner.fail("Issue date incorrect");
                if (String.format('%tY-%<tm-%<td', (it.MSG_RECEIPT_DT)) != receiptDate)
                    testRunner.fail("Receipt date incorrect");
                if (String.format('%tY-%<tm-%<td', (it.MSG_CRE_DT)) != receiptDate)
                    testRunner.fail("Creation date incorrect");
                if (it.MSG_DIRECTION != (String) messageType.messageDirection)
                    testRunner.fail("Message direction incorrect");
                switch (messageType)
                {
                    case MessageType.INVOICE:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.CREDITNOTE:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ATTACHEDDOCUMENT:
                    case MessageType.ATTACHEDDOCUMENTOUT:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.WILLINGNESS:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ACKNOWLEDGEMENT:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.REQUESTFORQUOTATION:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.PROPOSALREQUEST:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.QUOTATIONREQUEST:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ADHOCC2S:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ADHOCS2C:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.QUOTATION:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.PROPOSAL:
                        if ((it.MSG_AGR_ID).toString() != "22")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ORDERRESPONSESIMPLE:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ORDERRESPONSESIMPLEREJECTED:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ORDERCHANGE:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                        case MessageType.ORDER:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ORDERCANCELLATION:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.ORDERACKNOWLEDGEMENT:
                        if ((it.MSG_AGR_ID).toString() != msgAgrId)
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    case MessageType.CATALOGUE:
                        if ((it.MSG_AGR_ID).toString() != "25")
                            testRunner.fail("Message agreement ID incorrect");
                        break;
                    default:
                        log.error "messageType unknown";
                        testRunner.fail("messageType unknown");
                }
                if (parentId != "-1")
                {
                    if ((it.MSG_MSG_ID).toString() != parentId) 
                        testRunner.fail("Message parent ID incorrect");
                }
                else
                {
                    if (it.MSG_MSG_ID != null)
                        testRunner.fail("Message parent ID incorrect");
                }
                
                if( checkHumanReadableContent )
                {
                    def blob = it.getBlob ( "MSG_HUMANREADABLECONTENT" ) ;
                    def byte_stream = blob.getBinaryStream();
                    if( byte_stream == null )
                    {
                        testRunner.fail("No human readable content for message");
                    }
                }
            }
                
            if(numResults != 1)
            {
                log.error "Number of results should be 1, but is: " + numResults;
                testRunner.fail("Number of results incorrect");
            }

            numResults = 0;

            switch(messageType)
            {
                case MessageType.ORDERCHANGE:
                case MessageType.ORDERRESPONSESIMPLE:
                case MessageType.ORDERRESPONSESIMPLEREJECTED:
                case MessageType.ORDERCANCELLATION:
                case MessageType.ORDERACKNOWLEDGEMENT:
                    sql.eachRow("SELECT (TAB1.MSG_MST_CD) document_type, (TAB2.MSG_MST_CD) state, (TAB3.MSG_MST_CD) state2 FROM EPR_TB_MESSAGE TAB1, EPR_TB_MESSAGE TAB2, EPR_TB_MESSAGE TAB3 WHERE ( ( TAB1.MSG_DOCUMENTID = ${id}) AND ( TAB1.MSG_SUP_ID = ${msgSupId} ) AND ( TAB1.MSG_OBJ_ID = TAB2.MSG_OBJ_ID ) AND ( TAB1.MSG_OBJ_ID = TAB3.MSG_OBJ_ID ) AND ( TAB2.MSG_OBJ_ID = TAB3.MSG_OBJ_ID ) AND ( TAB1.MSG_ID != TAB2.MSG_ID ) AND ( TAB2.MSG_ID != TAB3.MSG_ID ) AND ( TAB1.MSG_ID != TAB3.MSG_ID ) AND ( TAB1.MSG_DIRECTION != TAB2.MSG_DIRECTION ) AND (TAB1.MSG_MST_CD = '" + messageType.toString() + "') )")
                    { 
                        numResults++;
                        if (messageType == MessageType.ORDERCHANGE)
                        {
                            if( it.document_type != "ORD_CHANGE_CANCEL")
                                testRunner.fail("Message state incorrect");
                            if( it.state != "ORDER")
                                testRunner.fail("Message type incorrect");
                        }
                        else if (messageType == MessageType.ORDERRESPONSESIMPLE)
                        {
                            if( it.document_type != "ORD_ACCEPTED")
                                testRunner.fail("Message state incorrect");
                            if( it.state != "ORDER")
                                testRunner.fail("Message type incorrect");
                        }
                        else if (messageType == MessageType.ORDERRESPONSESIMPLEREJECTED)
                        {
                            if( it.document_type != "ORD_RESPONSE_CANCEL")
                                testRunner.fail("Message state incorrect");
                            if( it.state != "ORDER")
                                testRunner.fail("Message type incorrect");
                        }
                        else if (messageType == MessageType.ORDERCANCELLATION)
                        {
                            if( it.document_type != "ORD_CANCELLATION_CANCEL")
                                testRunner.fail("Message state incorrect");
                            if( it.state2 != "ORDER" && it.state2 != "ORD_PROCESSED")
                                testRunner.fail("Message type incorrect");
                        }
                        else if (messageType == MessageType.ORDERACKNOWLEDGEMENT)
                        {
                            if( it.document_type != "ORD_PROCESSED")
                                testRunner.fail("Message state incorrect");
                            if( it.state2 != "ORDER")
                                testRunner.fail("Message type incorrect");
                        }
                    }
                    break;
                default:
                    sql.eachRow("SELECT (TAB1.MSG_MST_CD) document_type,(TAB2.MSG_MST_CD) state FROM EPR_TB_MESSAGE TAB1, EPR_TB_MESSAGE TAB2 WHERE ( ( TAB1.MSG_DOCUMENTID = ${id}) AND ( TAB1.MSG_SUP_ID = ${msgSupId} ) AND ( TAB1.MSG_OBJ_ID = TAB2.MSG_OBJ_ID ) AND ( TAB1.MSG_ID != TAB2.MSG_ID ) AND (TAB1.MSG_MST_CD = '" + messageType.toString() + "') )")
                    {
                        numResults++;
                        switch( messageState )
                        {
                            case MessageState.RECEIVED:
                            case MessageState.SENT:
                            case MessageState.PROCESSED:
                                if (it.state != messageType.getPrefix() + "_COMPLETE")
                                    testRunner.fail("Message state incorrect");
                                break;
                            case MessageState.REJECTED:
                                if (it.state != messageType.getPrefix() + "_CANCEL")
                                    testRunner.fail("Message state incorrect");
                                break;
                            default:
                                log.error "messageState unknown";
                                testRunner.fail("messageState unknown");
                        }
                    }
            }
            

            if(numResults != 1)
            {
                if( messageType == MessageType.ATTACHEDDOCUMENT )
                {
                    log.error "Number of results should be 1, but is: " + numResults;
                    testRunner.fail("Number of results incorrect");
                }
                if( messageState == MessageState.PROCESSED || messageState == MessageState.REJECTED)
                {
                    log.error "Number of results should be 1, but is: " + numResults;
                    testRunner.fail("Number of results incorrect");
                }
            }

            numResults = 0;

            sql.eachRow("SELECT * FROM EPR_TB_OBJECT WHERE (OBJ_ID = ${objId})")
            { 
                numResults++;
                if (it.OBJ_OBT_CD != messageType.getPrefix())
                    testRunner.fail("Message type incorrect");
                switch( messageState )
                {
                    case MessageState.RECEIVED:
                    case MessageState.PROCESSED:
                    case MessageState.REJECTED:
                    case MessageState.SENT:
                        if (! (it.OBJ_CORRELATIONID))
		                    testRunner.fail("Correlation ID not set");
                        break;
                    default:
                        log.error "messageState unknown";
                        testRunner.fail("messageState unknown");
                }
            }

            if(numResults != 1)
            {
                log.error "Number of results should be 1, but is: " + numResults;
                testRunner.fail("Number of results incorrect");
            }
        }
    }
    
    def verifyCanonicalMessage(MessageType messageType, MessageState messageState, boolean checkProcessingWarning = false, String parentId = "-1", String messageName="Request")
    {
        def id = findRequestId(messageType, messageName);
        def issueDate = findRequestDate(messageType, messageName);
        verifyCanonicalMessageById(id, issueDate, messageType, messageState, checkProcessingWarning, parentId, messageName);
    }
    
    def verifyCanonicalMessageJMS(MessageType messageType, MessageState messageState, boolean checkProcessingWarning = false, String parentId = "-1", String messageName='${Request#xml}')
    {
        def id = findRequestId(messageType, messageName, true);
        def issueDate = findRequestDate(messageType, messageName, true);
        verifyCanonicalMessageById(id, issueDate, messageType, messageState, checkProcessingWarning, parentId, messageName);
    }
    
    def verifyCanonicalMessageById(String id, String issueDate, MessageType messageType, MessageState messageState, boolean checkProcessingWarning, String parentId, String messageName)
    {
        def numResults = 0;

        if( messageState == MessageState.NON_EXISTING )
        {
            return;
        }
        
        sql.eachRow("SELECT MSG_CANONICALCONTENT, MSG_CRE_DT, MSG_RECEIPT_DT FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
        { 
            numResults++;
            def blob = it.getBlob ( "MSG_CANONICALCONTENT" ) ;
            
            switch( messageState )
            {
                case MessageState.RECEIVED:             
                case MessageState.PROCESSED:
                case MessageState.SENT:
                    def byte_stream = blob.getBinaryStream();
                    if( byte_stream == null )
                    {
                        testRunner.fail("Test: Received null stream!");
                    }
                    else
                    {
                        def rootnode = new groovy.util.XmlParser(false,false).parse(byte_stream);

                        switch (messageType)
                        {
                            case MessageType.INVOICE:
                                if( rootnode["urn:Invoice"] == "" )
                                    testRunner.fail("Original Invoice not set");
                                break;
                            case MessageType.CREDITNOTE:
                                if( rootnode["urn:CreditNote"] == "" )
                                    testRunner.fail("Original CreditNote not set");
                                break;
                            case MessageType.ATTACHEDDOCUMENT:
                            case MessageType.ATTACHEDDOCUMENTOUT:
                                if( rootnode["urn:AttachedDocument"] == "" )
                                    testRunner.fail("Original AttachedDocument not set");
                                if( rootnode["ec2:ECDocumentReceivedData"]["ec3:MimeCode"] == "" )
                                    testRunner.fail("Mime type not set");
                                break;
                            case MessageType.WILLINGNESS:
                                if( rootnode["urn:Willingness"] == "" )
                                    testRunner.fail("Original Willingness not set");
                                break;
                            case MessageType.ACKNOWLEDGEMENT:
                                if( rootnode["urn:Acknowledgement"] == "" )
                                    testRunner.fail("Original Acknowledgement not set");
                                break;
                            case MessageType.REQUESTFORQUOTATION:
                                if( rootnode["RequestForQuotation"] == "" )
                                    testRunner.fail("Original RequestForQuotation not set");
                                break;
                            case MessageType.PROPOSALREQUEST:
                                if( rootnode["ProposalRequest"] == "" )
                                    testRunner.fail("Original RequestForQuotation not set");
                                break;
                            case MessageType.QUOTATIONREQUEST:
                                if( rootnode["QuotationRequest"] == "" )
                                    testRunner.fail("Original QuotationRequest not set");
                                break;
                            case MessageType.ADHOCC2S:
                                if( rootnode["AdhocC2S"] == "" )
                                    testRunner.fail("Original AdhocC2S not set");
                                break;
                            case MessageType.ADHOCS2C:
                                if( rootnode["AdhocS2C"] == "" )
                                    testRunner.fail("Original AdhocS2C not set");
                                break;
                            case MessageType.QUOTATION:
                                if( rootnode["Quotation"] == "" )
                                    testRunner.fail("Original Quotation not set");
                                break;
                            case MessageType.PROPOSAL:
                                if( rootnode["Proposal"] == "" )
                                    testRunner.fail("Original Proposal not set");
                                break;
                            case MessageType.ORDERRESPONSESIMPLE:
                                if( rootnode["OrderResponseSimple"] == "" )
                                    testRunner.fail("Original OrderResponseSimple not set");
                                break;
                            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                                if( rootnode["OrderResponseSimple"] == "" )
                                    testRunner.fail("Original OrderResponseSimple not set");
                                break;
                            case MessageType.ORDERCHANGE:
                            if( rootnode["OrderChange"] == "" )
                                    testRunner.fail("Original OrderChange not set");
                                break;
                            case MessageType.ORDER:
                                if( rootnode["Order"] == "" )
                                    testRunner.fail("Original Order not set");
                                break;
                            case MessageType.ORDERCANCELLATION:
                                if( rootnode["OrderCancellation"] == "" )
                                    testRunner.fail("Original OrderCancellation not set");
                                break;
                            case MessageType.ORDERACKNOWLEDGEMENT:
                                if( rootnode["OrderAcknowledgement"] == "" )
                                    testRunner.fail("Original OrderAcknowledgement not set");
                                break;
                            case MessageType.CATALOGUE:
                                if( rootnode["urn:Catalogue"] == "" )
                                    testRunner.fail("Original Catalogue not set");
                                break;
                            default:
                                log.error "messageType unknown";
                        }

                        if(rootnode["urn:UBLVersionID"].text() == "")
                            testRunner.fail("UBLVersionID not set");

                        if(rootnode["urn:CustomizationID"].text() == "")
                            testRunner.fail("CustomizationID not set");

                        if(rootnode["urn:ProfileID"].text() == "")
                            testRunner.fail("ProfileID not set");

                        def rcvnode = rootnode["ec2:ECDocumentReceivedData"];
                        if(!rcvnode)
                            rcvnode = rootnode["ec1:ECDocumentReceivedData"];
                        if(!rcvnode)
                            rcvnode = rootnode["ecca:ECDocumentReceivedData"];
                            
                        if(rcvnode["urn:ID"].text() == "")
                            testRunner.fail("Object ID not set");

                        if(rcvnode["urn:ReceivedDate"].text() == "")
                            testRunner.fail("ReceivedDate not set");
                        else
                        {
                            String rcvdt = new String(rcvnode["urn:ReceivedDate"].text());
                            rcvdt = rcvdt.substring(0, rcvdt.indexOf('+'));
                            String regdt2 = (it.MSG_RECEIPT_DT).toString();
                            if( regdt2.indexOf(' ') > -1 )
                            regdt2 = regdt2.substring(0, regdt2.indexOf(' '));
                            if (rcvdt != regdt2)
                            testRunner.fail("Issue date does not match");
                        }
                        
                        if(rcvnode["ec3:RegistrationDate"].text() != "" )
                        {
                            String regdt = new String(rcvnode["ec3:RegistrationDate"].text());
                            regdt = regdt.substring(0, regdt.indexOf('+'));
                            if ((it.MSG_RECEIPT_DT).toString() != regdt)
                                testRunner.fail("Registration date does not match");
                        }
                        else if ( rcvnode["ec2:RegistrationDate"].text() != "")
                        {
                            String regdt = new String(rcvnode["ec2:RegistrationDate"].text());
                            regdt = regdt.substring(0, regdt.indexOf('+'));
                            if ((it.MSG_RECEIPT_DT).toString() != regdt)
                                testRunner.fail("Registration date does not match");
                        }
                        else if ( rcvnode["ecb:RegistrationDate"].text() != "")
                        {
                            String regdt = new String(rcvnode["ecb:RegistrationDate"].text());
                            regdt = regdt.substring(0, regdt.indexOf('+'));
                            String regdt2 = (it.MSG_RECEIPT_DT).toString();
                            regdt2 = regdt2.substring(0, regdt2.indexOf(' '));
                            if (regdt != regdt2)
                                testRunner.fail("Registration date does not match");
                        }
                        else
                            testRunner.fail("RegistrationDate not set");
                        
                        
                        if(rcvnode["ec3:CustomerID"].text() != "")
                        {
                            def orig = findRequestCustomerId(messageType, messageName);
                            if (rcvnode["ec3:CustomerID"].text() != orig)
                                testRunner.fail("CustomerID does not match");
                        }    
                        else if (rcvnode["ec2:CustomerID"].text() != "")
                        {
                            def orig = findRequestCustomerId(messageType, messageName, true);
                            if (rcvnode["ec2:CustomerID"].text() != orig)
                                testRunner.fail("CustomerID does not match");
                        }
                        else if (rcvnode["ecb:CustomerID"].text() != "")
                        {
                            def orig = findRequestCustomerId(messageType, messageName);
                            if (rcvnode["ecb:CustomerID"].text() != orig)
                                testRunner.fail("CustomerID does not match");
                        }
                        else
                             testRunner.fail("CustomerID not set");

                        if(rcvnode["ec3:SupplierID"].text() != "")
                        {
                            def orig = findRequestSupplierId(messageType, messageName);
                            if (rcvnode["ec3:SupplierID"].text() != orig)
                                testRunner.fail("SupplierID does not match");
                        }
                        else if(rcvnode["ec2:SupplierID"].text() != "")
                        {
                            def orig = findRequestSupplierId(messageType, messageName, true);
                            if (rcvnode["ec2:SupplierID"].text() != orig)
                                testRunner.fail("SupplierID does not match");
                        }
                        else if(rcvnode["ecb:SupplierID"].text() != "")
                        {
                            def orig = findRequestSupplierId(messageType, messageName);
                            if (rcvnode["ecb:SupplierID"].text() != orig)
                                testRunner.fail("SupplierID does not match");
                        }
                        else
                             testRunner.fail("SupplierID not set");

                        if(rcvnode["ec3:DepartmentID"].text() == "" && rcvnode["ec2:DepartmentID"].text() == "" && rcvnode["ecb:DepartmentID"].text() == "")
                            testRunner.fail("DepartmentID not set");

                        if(rcvnode["ec3:AccountPayableID"].text() == "" && rcvnode["ec2:AccountPayableID"].text() == "" && rcvnode["ecb:AccountPayableID"].text() == "")
                            testRunner.fail("AccountPayableID not set");

                        if(rcvnode["ec3:InternalID"].text() == "" && rcvnode["ec2:InternalID"].text() == "" && rcvnode["ecb:InternalID"].text() == "")
                            testRunner.fail("InternalID not set");
                        if( checkProcessingWarning )
                        {
                            if( ( (!(rcvnode["ec2:ProcessingWarning"][0])) || ( rcvnode["ec2:ProcessingWarning"][0].children().isEmpty() ) )
                             &&
                                ( (!(rcvnode["ecca:ProcessingWarning"][0])) || ( rcvnode["ecca:ProcessingWarning"][0].children().isEmpty() ) )
				     &&
                                ( (!(rcvnode["ec1:ProcessingWarning"][0])) || ( rcvnode["ec1:ProcessingWarning"][0].children().isEmpty() ) )
                             )

                                testRunner.fail("Processing warning NOT found");
                        }
                        else
                        {
                            if( ( (rcvnode["ec2:ProcessingWarning"][0]) && (! rcvnode["ec2:ProcessingWarning"][0].children().isEmpty()) )
                                ||
                                ( (rcvnode["ecca:ProcessingWarning"][0]) && (! rcvnode["ecca:ProcessingWarning"][0].children().isEmpty()) )
					  ||
                                ( (rcvnode["ec1:ProcessingWarning"][0]) && (! rcvnode["ec1:ProcessingWarning"][0].children().isEmpty()) )

                              )
                                testRunner.fail("Processing warning found");
                        }
                    }
                    break;
                case MessageState.REJECTED:
                    if( blob != null )
		                testRunner.fail("Canonical message should be null");
                    break;
                default:
                    log.error "messageState unknown";
                    testRunner.fail("messageState unknown");
            }
        }
    }
    
    def verifyHumanReadableContent(MessageType messageType, MessageState messageState, String initialisationName = null, String messageName="Request", String attachmentType = "html", boolean JMS = false)
    {
        def id = findRequestId(messageType, initialisationName, JMS);

        def response = testRunner.testCase.getTestStepByName("Request");
        def responseProperty = response.getProperty( "response" );

        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseProperty.value);
        String responseText = responseNode["soapenv:Body"]["ec:SubmitViewRequestResponse"];
        
        if( responseText == "[]" )
        {
            responseText = responseNode["SOAP-ENV:Body"]["ec:SubmitViewRequestResponse"];
        }
        
        if( attachmentType == "html" )
        {
            if( !responseText.contains(id) )
            {
                log.error "Response does not contain correct message id";
                testRunner.fail("Response does not contain correct message id");
            }
            
            if( !responseText.contains("<html") )
            {
                log.error "Response does not contain html message";
                testRunner.fail("Response does not contain html message");
            }
            
            switch (environment)
            {
            case TestEnvironment.TEST:
            case TestEnvironment.DEVELOPMENT:    
                def numResults = 0;
                sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
                { 
                    numResults++;

                    if ((it.MSG_HUMANREADABLEMIMETYPE).toString() != "text/html")
                        testRunner.fail("Human readable mime type incorrect");
                    
                }
                    
                if(numResults != 1)
                {
                    log.error "Number of results should be 1, but is: " + numResults;
                    testRunner.fail("Number of results incorrect");
                }
                break;
            case TestEnvironment.OPEN_EPRIOR_TEST:
            case TestEnvironment.ACCEPTANCE:
            case TestEnvironment.PROD:
                break;
            default:
                log.error "TestEnvironment unknown";        
            }
        }
        else if( attachmentType == "pdf" )
        {
            responseText = responseNode["soapenv:Body"]["ec:SubmitViewRequestResponse"]["ec:EmbeddedDocumentBinaryObject"].text();
        
            def b64 = new Base64();
            byte[] bytemessage = new byte[(int) responseText.length()];
            bytemessage = responseText.getBytes() 
            OutputStream out = new FileOutputStream("c:\\e-PRIOR.pdf");
            out.write(b64.decode(bytemessage));
            out.close();
            
            /*
            String decodedMessage = new String(b64.decode(bytemessage))
            if( !decodedMessage.contains(id) )
            {
                log.error "Response does not contain correct message id";
                testRunner.fail("Response does not contain correct message id");
            }
            
            if( !decodedMessage.contains("pdf") )
            {
                log.error "Response does not contain pdf message";
                testRunner.fail("Response does not contain pdf message");
            }
            */
            
            switch (environment)
            {
            case TestEnvironment.TEST:
            case TestEnvironment.DEVELOPMENT:    
                def numResults = 0;
                sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType.toString() + "') AND (MSG_SUP_ID = ${msgSupId}) )")
                { 
                    numResults++;

                    if ((it.MSG_HUMANREADABLEMIMETYPE).toString() != "application/pdf")
                        testRunner.fail("Human readable mime type incorrect");
                    
                }
                    
                if(numResults != 1)
                {
                    log.error "Number of results should be 1, but is: " + numResults;
                    testRunner.fail("Number of results incorrect");
                }
                break;
            case TestEnvironment.OPEN_EPRIOR_TEST:
            case TestEnvironment.ACCEPTANCE:
            case TestEnvironment.PROD:
                break;
            default:
                log.error "TestEnvironment unknown";        
            }
        }
        
    }
    
    def verifyRetrievedDocument(MessageType messageType, MessageState messageState, boolean messageReadFlag = true, String initialisationName = null, String messageName="Request", boolean JMS = false)
    {
        def responseStep = testRunner.testCase.getTestStepByName(messageName);
        def responseResponse = responseStep.getProperty( "response" );

        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseResponse.value);
        def responseXml = null;
        
        if( messageState == MessageState.NON_EXISTING )
        {
            def node = responseNode["soapenv:Body"]["ec:SubmitRetrieveRequestResponse"]["ec:RetrieveResponse"]["ec1:DocumentContent"][0];
            def numChildren = node.children().size();

            if( numChildren > 0 )
            {
                testRunner.fail("Response should be empty");
            }
            return;
        }
        
        def submitDocument = null;
        
        if(JMS)
        {
            def text = context.expand( initialisationName );
            submitDocument = new groovy.util.XmlParser(false,false).parseText(text);
        }
        else
        {
            def submitStep = testRunner.testCase.getTestStepByName(initialisationName);
            def submitRequest = submitStep.getProperty( "request" );
            submitDocument = new groovy.util.XmlParser(false,false).parseText(submitRequest.value);
        }
        
        def submitXml = null;
        
        switch (messageType)
        {
            case MessageType.INVOICE:
                submitDocument."SOAP-ENV:Body"."ec:SubmitInvoiceRequest"."ec:Invoice"[0].@"xmlns:ec" = "urn:oasis:names:specification:ubl:schema:xsd:Invoice-2";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitInvoiceRequest"."ec:Invoice"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."urn:Invoice"[0];
                break;
            case MessageType.CREDITNOTE:
                submitDocument."SOAP-ENV:Body"."ec:SubmitCreditNoteRequest"."ec:CreditNote"[0].@"xmlns:ec" = "urn:oasis:names:specification:ubl:schema:xsd:CreditNote-2";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitCreditNoteRequest"."ec:CreditNote"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."urn:CreditNote"[0];
                break;
            case MessageType.ATTACHEDDOCUMENT:
            case MessageType.ATTACHEDDOCUMENTOUT:
                submitDocument."SOAP-ENV:Body"."ec:SubmitAttachedDocumentRequest"."ec:AttachedDocument"[0].@"xmlns:ec" = "urn:oasis:names:specification:ubl:schema:xsd:AttachedDocument-2";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitAttachedDocumentRequest"."ec:AttachedDocument"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."urn:AttachedDocument"[0];
            
                def binaryContent = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."urn:AttachedDocument"."cac:Attachment"[0];

                if(binaryContent.text() != "")
                {
                    testRunner.fail("Binary content found in retrieved document when this was not expected");
                }
                break;
            case MessageType.REQUESTFORQUOTATION:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."RequestForQuotation"[0];
                break;
            case MessageType.ADHOCC2S:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."AdhocC2S"[0];
                break;
            case MessageType.ADHOCS2C:
                submitDocument."SOAP-ENV:Body"."ec:SubmitAdhocS2CRequest"."ec:AdhocS2C"[0].@"xmlns:ec" = "ec:schema:xsd:AdhocS2C-0.1";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitAdhocS2CRequest"."ec:AdhocS2C"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."ec1:AdhocS2C"[0];
                break;
            case MessageType.QUOTATION:
                submitDocument."SOAP-ENV:Body"."ec:SubmitQuotationRequest"."ec:Quotation"[0].@"xmlns:ec" = "ec:schema:xsd:Quotation-0.1";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitQuotationRequest"."ec:Quotation"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."ec1:Quotation"[0];
                break;
            case MessageType.PROPOSAL:
                submitDocument."SOAP-ENV:Body"."ec:SubmitProposalRequest"."ec:Proposal"[0].@"xmlns:ec" = "ec:schema:xsd:Proposal-0.1";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitProposalRequest"."ec:Proposal"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."ec1:Proposal"[0];
                break;
            case MessageType.ORDERRESPONSESIMPLE:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."OrderResponseSimple"[0];
                break;
            case MessageType.ORDERRESPONSESIMPLEREJECTED:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."OrderResponseSimple"[0];
                break;
            case MessageType.ORDERCHANGE:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."OrderChange"[0];
                break;
            case MessageType.ACKNOWLEDGEMENT:
                submitDocument."SOAP-ENV:Body"."ec:SubmitAcknowledgementRequest"."ec:Acknowledgement"[0].@"xmlns:ec" = "ec:schema:xsd:Acknowledgement-0.1";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitAcknowledgementRequest"."ec:Acknowledgement"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."ec1:Acknowledgement"[0];
                break;
            case MessageType.WILLINGNESS:
                submitDocument."SOAP-ENV:Body"."ec:SubmitWillingnessRequest"."ec:Willingness"[0].@"xmlns:ec" = "ec:schema:xsd:Willingness-0.1";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitWillingnessRequest"."ec:Willingness"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."ec1:Willingness"[0];
                break;
            case MessageType.PROPOSALREQUEST:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."ProposalRequest"[0];
                break;
            case MessageType.QUOTATIONREQUEST:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."QuotationRequest"[0];
                break;
            case MessageType.ORDER:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."Order"[0];
                break;
            case MessageType.ORDERCANCELLATION:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."OrderCancellation"[0];
                break;
            case MessageType.ORDERACKNOWLEDGEMENT:
                submitXml = submitDocument;
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."OrderAcknowledgement"[0];
                break;
            case MessageType.CATALOGUE:
                submitDocument."SOAP-ENV:Body"."ec:SubmitCatalogueRequest"."ec:Catalogue"[0].@"xmlns:ec" = "urn:oasis:names:specification:ubl:schema:xsd:Catalogue-2";
                submitXml = submitDocument."SOAP-ENV:Body"."ec:SubmitCatalogueRequest"."ec:Catalogue"[0];
                responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."urn:Catalogue"[0];
                break;
            default:
                log.error "messageType unknown";
        }

        // check the whole document using XmlUnit
        def submitWriter = new StringWriter()
        new XmlNodePrinter(new PrintWriter(submitWriter)).print(submitXml)
        def submitResult = submitWriter.toString()

        // check the whole document using XmlUnit
        def responseWriter = new StringWriter()
        new XmlNodePrinter(new PrintWriter(responseWriter)).print(responseXml)
        def responseResult = responseWriter.toString()

        def xmlDiff2 = new Diff(submitResult, responseResult)
        if( !(xmlDiff2.similar()) )
        {
            testRunner.fail("Retrieved document does not equal submitted document");
        }

        def id = findRequestId(messageType, initialisationName, JMS);

        verifyMsgReadFlag(messageType.toString(), id, messageReadFlag);
    }
    
    def verifyMsgReadFlag(String messageType, String id, boolean messageReadFlag = true)
    {
        def numResults = 0;

        sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE ( (MSG_DOCUMENTID = ${id}) AND (MSG_MST_CD = '" + messageType + "') AND (MSG_SUP_ID = ${msgSupId}) )")
        { 
            numResults++;

            if( messageReadFlag )
            {
                if( (it.MSG_READ_FL).toString() != "Y" )
                    testRunner.fail("Message read flag incorrect");
            }
            else
            {
                if( (it.MSG_READ_FL).toString() != "N" )
                    testRunner.fail("Message read flag incorrect");
            }
        }

        if( numResults != 1  )
        {
            testRunner.fail("Number of matching documents incorrect");
        }
    }
    
    def verifyRetrievedOutboundDocument(MessageType messageType, MessageState messageState, boolean messageReadFlag = true, String initialisationName = null, String messageName="Request", boolean binaryContentExpected = false, String id = null)
    {
        def responseStep = testRunner.testCase.getTestStepByName(messageName);
        def responseResponse = responseStep.getProperty( "response" );

        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseResponse.value);
        if( binaryContentExpected )
        {
            if( ! ( responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"."mdatt:AttachedDocument"."urn1:Attachment"."urn:EmbeddedDocumentBinaryObject"[0].text() ) )
            {
                testRunner.fail("No binary content found");
            }
        }

        if(id == null)
            id = findRequestId(messageType, initialisationName);

        verifyMsgReadFlag(messageType.toString(), id, messageReadFlag);
    }
    
    def verifyStatusRequest(MessageType messageType, MessageState messageState, String initialisationName = null, String messageName = "Request", boolean JMS = false)
    {
        def issueDate = findRequestDate(messageType, initialisationName, JMS);
        
        def response = testRunner.testCase.getTestStepByName(messageName);
        def responseProperty = response.getProperty("response");

        def statusRequest = testRunner.testCase.getTestStepByName(messageName);
        def statusRequestProperty = statusRequest.getProperty("request");

        def statusRequestNode = new groovy.util.XmlParser(false,false).parseText(statusRequestProperty.value);
        def id = statusRequestNode["SOAP-ENV:Body"]["ec:SubmitStatusRequestRequest"]["ec:StatusRequest"]["eccac:DocumentReferenceRequest"]["cbc:ID"].text();
        def documentTypeCode = statusRequestNode["SOAP-ENV:Body"]["ec:SubmitStatusRequestRequest"]["ec:StatusRequest"]["eccac:DocumentReferenceRequest"]["cbc:DocumentTypeCode"].text();

        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseProperty.value);
        def responseId = responseNode["soapenv:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec1:DocumentReferenceResponseRelatedDocs"]["ec1:DocumentReferenceResponse"]["urn:ID"].text();
        if( responseId == "" )
            responseId = responseNode["SOAP-ENV:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec:DocumentReferenceResponseRelatedDocs"]["ec:DocumentReferenceResponse"]["urn:ID"].text();
        def responseDate = responseNode["soapenv:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec1:DocumentReferenceResponseRelatedDocs"]["ec1:DocumentReferenceResponse"]["urn:IssueDate"].text();
        if( responseDate == "" )
            responseDate = responseNode["SOAP-ENV:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec:DocumentReferenceResponseRelatedDocs"]["ec:DocumentReferenceResponse"]["urn:IssueDate"].text();
        def responseStatusCode = responseNode["soapenv:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec1:DocumentReferenceResponseRelatedDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentStatusCode"].text();
        if( responseStatusCode == "" )
            responseStatusCode = responseNode["SOAP-ENV:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec:DocumentReferenceResponseRelatedDocs"]["ec:DocumentReferenceResponse"]["urn:DocumentStatusCode"].text();
        def responseDocumentTypeCode = responseNode["soapenv:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec1:DocumentReferenceResponseRelatedDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
        if( responseDocumentTypeCode == "" )
            responseDocumentTypeCode = responseNode["SOAP-ENV:Body"]["ec:SubmitStatusRequestResponse"]["ec:StatusResponse"]["ec:DocumentReferenceResponseRelatedDocs"]["ec:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
        
        if( responseId != id )
        {
            log.error "The ID of the status response does not match";
            testRunner.fail("Status response ID incorrect");
        }

        switch( messageState )
        {
            case MessageState.RECEIVED:
            case MessageState.PROCESSED:
                if( responseStatusCode != "1" && responseStatusCode != "2" )
                {
                    log.error "The response code of the status response does not match";
                    testRunner.fail("Status response response code incorrect");
                }
                if( responseDate != issueDate )
                {
                    log.error "The date of the status response does not match";
                    testRunner.fail("Status response date incorrect");
                }
                break;
            case MessageState.REJECTED:
                if( responseStatusCode != "3" )
                {
                    log.error "The response code of the status response does not match";
                    testRunner.fail("Status response response code incorrect");
                }
                break;
            case MessageState.NON_EXISTING:
                if( responseStatusCode != "0" )
                {
                    log.error "The response code of the status response does not match";
                    testRunner.fail("Status response response code incorrect");
                }
                break;
            case MessageState.SENT:
                if( responseStatusCode != "4" )
                {
                    log.error "The response code of the status response does not match";
                    testRunner.fail("Status response response code incorrect");
                }
                break;
            case MessageState.ACCEPTED:
                if( responseStatusCode != "5" )
                {
                    log.error "The response code of the status response does not match";
                    testRunner.fail("Status response response code incorrect");
                }
                break;
            default:
                log.error "messageState unknown";
                testRunner.fail("messageState unknown");
        }

        if( responseDocumentTypeCode != documentTypeCode )
        {
            log.error "The document type code of the status response does not match";
            testRunner.fail("Status response document type code incorrect");
        }
    }
    
    def AdditionalStatusRequestVerification(StatusRequestMode statusRequestMode, String messageName = "Request")
    {
        def response = testRunner.testCase.getTestStepByName(messageName);
        def responseProperty = response.getProperty("response");

        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseProperty.value);

        switch( statusRequestMode )
        {
            case StatusRequestMode.NO_RELATED_DOCUMENTS:
                def numberRelatedDocs = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs"."ec1:RelatedDocument".size();
                if( numberRelatedDocs > 0 )
                {
                    if( numberRelatedDocs > 1 )
                    {
                        log.error "Too many related documents";
                        testRunner.fail("Too many related documents");
                    }
                    else
                    {
                        def relatedDocumentType = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs"."ec1:RelatedDocument"."urn:DocumentTypeCode"[0].text();
                        if( relatedDocumentType != "301" )
                        {
                            log.error "Too many related documents";
                            testRunner.fail("Too many related documents");
                        }
                    }
                }
                
                numberRelatedDocs = responseNode."SOAP-ENV:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec:DocumentReferenceResponseRelatedDocs"."ec:RelatedDocument".size();
                if( numberRelatedDocs > 0 )
                {
                    if( numberRelatedDocs > 1 )
                    {
                        log.error "Too many related documents";
                        testRunner.fail("Too many related documents");
                    }
                    else
                    {
                        def relatedDocumentType = responseNode."SOAP-ENV:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec:DocumentReferenceResponseRelatedDocs"."ec:RelatedDocument"."urn:DocumentTypeCode"[0].text();
                        if( relatedDocumentType != "301" )
                        {
                            log.error "Too many related documents";
                            testRunner.fail("Too many related documents");
                        }
                    }
                }
                
                break;
            case StatusRequestMode.APPLICATION_RESPONSE:
                def numberRelatedDocs = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs"."ec1:RelatedDocument".size();

                def applicationResponseFound = false;

                for( int i = 0; i < numberRelatedDocs; i++  )
                {
                    def relatedDocumentType = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs"."ec1:RelatedDocument"."urn:DocumentTypeCode"[i].text();
                    if( relatedDocumentType == "301" )
                    {
                        applicationResponseFound = true;
                    }
                }

                numberRelatedDocs = responseNode."SOAP-ENV:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec:DocumentReferenceResponseRelatedDocs"."ec:RelatedDocument".size();

                for( int i = 0; i < numberRelatedDocs; i++  )
                {
                    def relatedDocumentType = responseNode."SOAP-ENV:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec:DocumentReferenceResponseRelatedDocs"."ec:RelatedDocument"."urn:DocumentTypeCode"[i].text();
                    if( relatedDocumentType == "301" )
                    {
                        applicationResponseFound = true;
                    }
                }

                if( !applicationResponseFound  )
                {
                    log.error "Application Response not found in related documents";
                    testRunner.fail("Application Response not found in related documents");
                }
                break;
            case StatusRequestMode.MAX_ONE_NOT_REJECTED:
                def numberMatchingDocs = -1;
                
                if( responseNode."soapenv:Body".size() > 0 )
                    numberMatchingDocs = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs".size();
                else
                    numberMatchingDocs = responseNode."SOAP-ENV:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec:DocumentReferenceResponseRelatedDocs".size();
                    
                if( numberMatchingDocs != 1 )
                {
                    log.error "The number of related documents does not match";
                    testRunner.fail("The number of related documents does not match");
                }

                def stateRejected = 0;
                def stateInProcess = 0;
                def stateAccepted = 0;

                for( int i = 0; i < numberMatchingDocs; i++ )
                {
                    def state = -1;
                    
                    if( responseNode."soapenv:Body".size() > 0 )
                        state = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs"."ec1:DocumentReferenceResponse"[i]."urn:DocumentStatusCode".text();
                    else
                        state = responseNode."SOAP-ENV:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec:DocumentReferenceResponseRelatedDocs"."ec:DocumentReferenceResponse"[i]."urn:DocumentStatusCode".text();
                        
                    switch( state )
                    {
                        case "1":
                            stateInProcess++;
                            break;
                        case "2":
                            stateAccepted++;
                            break;
                        case "3":
                            stateRejected++;
                            break;
                        default:
                            log.error "Invalid state of matching document";
                            testRunner.fail("Invalid state of matching document");
                    }
                }

                if( stateAccepted > 1 )
                {
                    log.error "The state of matching documents does not match";
                    testRunner.fail("The state of matching documents does not match");
                }

                if( stateRejected < numberMatchingDocs - 1 )
                {
                    log.info "Please check state of matching documents";
                    log.info "stateInProcess: " + stateInProcess + " stateAccepted: " + stateAccepted + " stateRejected: " + stateRejected; 
                }
                break;
                case StatusRequestMode.ONLY_DIRECT_REFERENCE:
                    def numberMatchingDocs = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs".size();

                    if( numberMatchingDocs > 2 )
                    {
                        log.error "The number of related documents does not match";
                        testRunner.fail("The number of related documents does not match");
                    }

                    def numberApplicationResponses = 0;

                    for( int i = 0; i < numberMatchingDocs; i++ )
                    {
                        def type = responseNode."soapenv:Body"."ec:SubmitStatusRequestResponse"."ec:StatusResponse"."ec1:DocumentReferenceResponseRelatedDocs"."ec1:DocumentReferenceResponse"[i]."urn:DocumentTypeCode".text();
                        if (type == "301")
                            numberApplicationResponses++;
                    }

                    if( numberApplicationResponses > 1 )
                    {
                        log.error "The number of application responses does not match";
                        testRunner.fail("The number of application responses does not match");
                    }
                break;
            default:
                log.error "statusRequestMode unknown";
                testRunner.fail("statusRequestMode unknown");
        }
    }
    
    def verifyInboxRequest(MessageType messageType, MessageType initialisationType, MessageState messageState, String initialisationName = null, String messageName = "Request")
    {
        def responseStep = testRunner.testCase.getTestStepByName(messageName);
        def responseResponse = responseStep.getProperty("response");

        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseResponse.value);
        
        def documentStatusCode = -1;
        
        switch( messageState )
        {
            case MessageState.PROCESSED:
                def node = -1;
                if( responseNode."soapenv:Body".size() > 0 )
                    node = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:ParentDocument"]["urn:DocumentStatusCode"];
                else
                    node = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:ParentDocument"]["urn:DocumentStatusCode"];
                documentStatusCode = node.text();

                if( documentStatusCode != "2" )
                {
                    log.error("DocumentStatusCode incorrect");
                    testRunner.fail("DocumentStatusCode incorrect");
                }
                break;
            case MessageState.SENT:
                def node = -1;
                if( responseNode."soapenv:Body".size() > 0 )
                    node = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentStatusCode"];
                else
                    node = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["urn:DocumentStatusCode"];
                documentStatusCode = node.text();

                if( documentStatusCode != "4" )
                {
                    log.error("DocumentStatusCode incorrect");
                    testRunner.fail("DocumentStatusCode incorrect");
                }
                break;
            case MessageState.ACCEPTED:
                def node = -1;
                if( responseNode."soapenv:Body".size() > 0 )
                    node = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentStatusCode"];
                else
                    node = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["urn:DocumentStatusCode"];
                documentStatusCode = node.text();

                if( documentStatusCode != "5" )
                {
                    log.error("DocumentStatusCode incorrect");
                    testRunner.fail("DocumentStatusCode incorrect");
                }
                break;
            case MessageState.REJECTED:
                def node = -1;
                if( responseNode."soapenv:Body".size() > 0 )
                    node = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:ParentDocument"]["urn:DocumentStatusCode"];
                else
                    node = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:ParentDocument"]["urn:DocumentStatusCode"];
                    
                if( messageType == MessageType.ORDER)
                {
                    if( responseNode."soapenv:Body".size() > 0 )
                        node = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentStatusCode"];
                    else
                        node = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["urn:DocumentStatusCode"];
                }
                
                documentStatusCode = node.text();

                if( documentStatusCode != "3" )
                {
                    log.error("DocumentStatusCode incorrect");
                    testRunner.fail("DocumentStatusCode incorrect");
                }
                break;
            case MessageState.RECEIVED:
            case MessageState.NON_EXISTING:
                def node = -1;
                if( responseNode."soapenv:Body".size() > 0 )
                    node = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"][0];
                else
                    node = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"][0];
                
                def numChildren = node.children().size();

                if( numChildren > 0 )
                {
                    testRunner.fail("Response should be empty");
                }
                break;
            default:
                log.error "messageState unknown";
                testRunner.fail("messageState unknown");
        }
        
        switch( messageType )
        {
            case MessageType.APPLICATIONRESPONSE:
                def now = new Date();
                def receiptDate = String.format('%tY-%<tm-%<td', now);
                def responseDate = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:IssueDate"].text();
                if( responseDate == "" )
                    responseDate = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["urn:IssueDate"].text();    
                if( responseDate != receiptDate )
                {
                    log.error "The issueDate of the inbox response does not match";
                    testRunner.fail("Inbox response issueDate incorrect");
                }
                
                def responseDocumentTypeCode = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
                if( responseDocumentTypeCode == "" )
                    responseDocumentTypeCode = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
                if( responseDocumentTypeCode != messageType.getDocumentTypeCode() )
                {
                    log.error "The DocumentTypeCode of the inbox response does not match";
                    testRunner.fail("Inbox response DocumentTypeCode incorrect");
                }
                
                def responseCustomerId = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["ec2:CustomerID"].text();
                if( responseCustomerId == "" )
                    responseCustomerId = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["ec1:CustomerID"].text();
                
                if( findRequestCustomerId(initialisationType, initialisationName) != responseCustomerId)
                {
                    log.error "The CustomerID of the query response does not match";
                    testRunner.fail("Query response CustomerID incorrect");
                }
                
                def responseResponseCode = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:ResponseCode"].text();
                if( responseResponseCode == "" )
                    responseResponseCode = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:DocumentReferenceResponse"]["urn:ResponseCode"].text();
                    
                if( !(responseResponseCode.contains(initialisationType.getDocumentTypeCode() + ":") ) )
                {
                    log.info responseResponseCode
                    log.info initialisationType.getPrefix()
                    log.error "The response code of the Inbox response does not match";
                    testRunner.fail("Inbox response ResponseCode incorrect");
                }
                
                def parentID = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:ParentDocument"]["urn:ID"].text();
                if( parentID == "" )
                    parentID = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:ParentDocument"]["urn:ID"].text();
                    
                if( parentID != findRequestId(initialisationType, initialisationName) )
                {
                    log.error "The parent document ID of the Inbox response does not match";
                    testRunner.fail("Inbox response parent document ID incorrect");
                }
                
                def parentIssueDate = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:ParentDocument"]["urn:IssueDate"].text();
                if( parentIssueDate == "" )
                    parentIssueDate = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:ParentDocument"]["urn:IssueDate"].text();
                    
                if( parentIssueDate != findRequestDate(initialisationType, initialisationName) )
                {
                    log.error "The parent document issue date of the Inbox response does not match";
                    testRunner.fail("Inbox response parent document issue date incorrect");
                }
                
                def parentDocumentTypeCode = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:ParentDocument"]["urn:DocumentTypeCode"].text();
                if( parentDocumentTypeCode == "" )
                    parentDocumentTypeCode = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:ParentDocument"]["urn:DocumentTypeCode"].text();
                    
                if( parentDocumentTypeCode != initialisationType.getDocumentTypeCode() )
                {
                    log.error "The parent document DocumentTypeCode of the Inbox response does not match";
                    testRunner.fail("Inbox response parent document DocumentTypeCode incorrect");
                }
                
                def parentDocumentStatusCode = responseNode["soapenv:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:ParentDocument"]["urn:DocumentStatusCode"].text();
                if( parentDocumentStatusCode == "" )
                    parentDocumentStatusCode = responseNode["SOAP-ENV:Body"]["ec:SubmitInboxRequestResponse"]["ec:InboxResponse"]["ec:DocumentReferenceResponseParentDocs"][0]["ec:ParentDocument"]["urn:DocumentStatusCode"].text();                    
                    
                if( parentDocumentStatusCode != documentStatusCode )
                {
                    log.error "The parent document DocumentStatusCode of the Inbox response does not match";
                    testRunner.fail("Inbox response parent document DocumentStatusCode incorrect");
                }
                
                break;
            default:
                // do not do anything
                break;
        }
    }
    
    def verifyQueryRequest(MessageType messageType, MessageState messageState, String initialisationName = null, String messageName = "Request", boolean testNoChildren = false, boolean JMS = false)
    {
        def response = testRunner.testCase.getTestStepByName(messageName);
        def responseProperty = response.getProperty("response");
        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseProperty.value);
        
        if( messageState == MessageState.NON_EXISTING)
        {
            def numChildren = -1;
            
            if( responseNode."soapenv:Body".size() > 0 )
                numChildren = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"][0].children().size();
            else
                numChildren = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"][0].children().size();
                
            if( numChildren > 0 )
            {
                testRunner.fail("Response should be empty");
            }
            return;
        }
                
        def id = findRequestId(messageType, initialisationName, JMS);
        def issueDate = findRequestDate(messageType, initialisationName, JMS);

        def queryRequest = testRunner.testCase.getTestStepByName(messageName);
        def queryRequestProperty = queryRequest.getProperty("request");

        def queryRequestNode = new groovy.util.XmlParser(false,false).parseText(queryRequestProperty.value);
        
        def responseId = -1;
        def responseDate = -1;
        def responseStatusCode = -1;
        def responseDocumentTypeCode = -1;
        def responseCustomerId = -1;
        
        if( responseNode."soapenv:Body".size() > 0 )
        {
            responseId = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:ID"].text();
            responseDate = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:IssueDate"].text();
            responseStatusCode = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentStatusCode"].text();
            responseDocumentTypeCode = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
            responseCustomerId = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["ec2:CustomerID"].text();
        }
        else
        {
            responseId = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:ID"].text();
            responseDate = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:IssueDate"].text();
            responseStatusCode = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:DocumentStatusCode"].text();
            responseDocumentTypeCode = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
            responseCustomerId = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["ec1:CustomerID"].text();
        }
        
        if( responseId != id )
        {
            log.error "The ID of the query response does not match";
            testRunner.fail("Query response ID incorrect");
        }

        if( findRequestCustomerId(messageType, initialisationName, JMS) != responseCustomerId)
        {
            log.error "The CustomerID of the query response does not match";
            testRunner.fail("Query response CustomerID incorrect");
        }

        switch( messageState )
        {
            case MessageState.RECEIVED:
            case MessageState.PROCESSED:
                if( responseStatusCode != "1" && responseStatusCode != "2" )
                {
                    log.error "The response code of the query response does not match";
                    testRunner.fail("Query response response code incorrect");
                }
                if( responseDate != issueDate )
                {
                    log.error "The issueDate of the query response does not match";
                    testRunner.fail("Query response issueDate incorrect");
                }
                break;
            case MessageState.REJECTED:
                if( responseStatusCode != "3" )
                {
                    log.error "The response code of the query response does not match";
                    testRunner.fail("Query response response code incorrect");
                }
                break;
            case MessageState.SENT:
                if( responseStatusCode != "4" )
                {
                    log.error "The response code of the query response does not match";
                    testRunner.fail("Query response response code incorrect");
                }
                break;
            default:
                log.error "messageState unknown";
                testRunner.fail("messageState unknown");
        }

        if( responseDocumentTypeCode != messageType.getDocumentTypeCode() )
        {
            log.error "The DocumentTypeCode of the query response does not match";
            testRunner.fail("Query response DocumentTypeCode incorrect");
        }
        
        if( testNoChildren )
        {
            def numChildren =  -1;
            if( responseNode."soapenv:Body".size() > 0 )
                numChildren = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"][0].children().size();
            else
                numChildren = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"][0].children().size();

            if( numChildren > 1 )
            {
                testRunner.fail("Parent Document should be empty");
            }
        }
    }
    
    def verifyQueryRequestApplicationResponse(MessageType messageType, String initialisationName = null, String messageName = "Request")
    {
        def response = testRunner.testCase.getTestStepByName(messageName);
        def responseProperty = response.getProperty("response");
        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseProperty.value);
        
        def now = new Date();
        def receiptDate = String.format('%tY-%<tm-%<td', now);

        def queryRequest = testRunner.testCase.getTestStepByName(messageName);
        def queryRequestProperty = queryRequest.getProperty("request");

        def queryRequestNode = new groovy.util.XmlParser(false,false).parseText(queryRequestProperty.value);

        def responseId = -1;
        def responseDate = -1;
        def responseStatusCode = -1;
        def responseDocumentTypeCode = -1;
        def responseResponseCode = -1;
        def responseCustomerId = -1;

        if( responseNode."soapenv:Body".size() > 0 )
        {        
            responseId = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:ID"].text();
            responseDate = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:IssueDate"].text();
            responseStatusCode = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentStatusCode"].text();
            responseDocumentTypeCode = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
            responseResponseCode = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["urn:ResponseCode"].text();
            responseCustomerId = responseNode["soapenv:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec1:DocumentReferenceResponseParentDocs"]["ec1:DocumentReferenceResponse"]["ec2:CustomerID"].text();
        }
        else
        {
            responseId = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:ID"].text();
            responseDate = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:IssueDate"].text();
            responseStatusCode = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:DocumentStatusCode"].text();
            responseDocumentTypeCode = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:DocumentTypeCode"].text();
            responseResponseCode = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["urn:ResponseCode"].text();
            responseCustomerId = responseNode["SOAP-ENV:Body"]["ec:SubmitQueryRequestResponse"]["ec:QueryResponse"]["ec:DocumentReferenceResponseParentDocs"]["ec:DocumentReferenceResponse"]["ec1:CustomerID"].text();
        }
        
        if( findRequestCustomerId(messageType, initialisationName) != responseCustomerId)
        {
            log.info responseCustomerId;
            log.info findRequestCustomerId(messageType, initialisationName);
            log.error "The CustomerID of the query response does not match";
            testRunner.fail("Query response CustomerID incorrect");
        }

        if( responseDate != receiptDate )
        {
            log.error "The issueDate of the query response does not match";
            testRunner.fail("Query response issueDate incorrect");
        }

        if( ! responseResponseCode.contains(":4") )
        {
            log.error "The response code of the query response does not match";
            testRunner.fail("Query response response code incorrect");
        }

        if( responseDocumentTypeCode != "301" )
        {
            log.error "The DocumentTypeCode of the query response does not match";
            testRunner.fail("Query response DocumentTypeCode incorrect");
        }
        
        if( responseStatusCode != "" )
        {
            log.error "The DocumentStatusCode of the query response does not match";
            testRunner.fail("Query response DocumentStatusCode incorrect");
        }
    }
    
    def verifyApplicationResponse(String docId, String responseCode, String description, MessageType initialisationType = null, String initialisationName = null, boolean errorObject = false, boolean checkDocumentReferenceId = true, String msgId = '-1', boolean JMS = false)
    {
        def parentId = findRequestId(initialisationType, initialisationName, JMS);
	    def numResults = 0;
        sql.eachRow("SELECT * FROM EPR_TB_MESSAGE WHERE (MSG_ID = ${docId})")
        {
            if (errorObject)
            {
                def blob = it.getBlob ( "MSG_CANONICALCONTENT" ) ;
                def byte_stream = blob.getBinaryStream();
                if( byte_stream == null )
                {
                    testRunner.fail("Test: Received null stream!");
                }
                else
                {
                    def rootnode = new groovy.util.XmlParser(false,false).parse(byte_stream);
                    if( (msgId != '-1') && ( rootnode["urn:ID"].text() != msgId ) && ( rootnode["urn1:ID"].text() != msgId ) && ( rootnode["cbc:ID"].text() != msgId ) )
                        testRunner.fail("Application Response, ID incorrect");
                    if( ( rootnode["urn1:DocumentResponse"]["urn1:Response"]["urn2:ResponseCode"].text() != responseCode ) && ( rootnode["cac:DocumentResponse"]["cac:Response"]["cbc:ResponseCode"].text() != responseCode ) )
                    {
                        testRunner.fail("Application Response, Response Code incorrect");
                    }
                    if( ( description != null ) && ( rootnode["urn1:DocumentResponse"]["urn1:Response"]["urn2:Description"].text() != description ) && ( rootnode["cac:DocumentResponse"]["cac:Response"]["cbc:Description"].text() != description ) )
                        testRunner.fail("Application Response, Description incorrect");
                    if( parentId != -1 && checkDocumentReferenceId )
                    {
                        if( ( rootnode["urn1:DocumentResponse"]["urn2:DocumentReference"]["urn2:ID"].text() != parentId ) && ( rootnode["urn1:DocumentResponse"]["urn1:DocumentReference"]["urn2:ID"].text() != parentId ) && ( rootnode["cac:DocumentResponse"]["cac:DocumentReference"]["cbc:ID"].text() != parentId ) )
                            testRunner.fail("Application Response, Parent ID incorrect");
                        if( ( rootnode["urn1:DocumentResponse"]["urn2:DocumentReference"]["urn2:DocumentTypeCode"].text() != initialisationType.getDocumentTypeCode() ) && ( rootnode["urn1:DocumentResponse"]["urn1:DocumentReference"]["urn2:DocumentTypeCode"].text() != initialisationType.getDocumentTypeCode() ) && ( rootnode["cac:DocumentResponse"]["cac:DocumentReference"]["cbc:DocumentTypeCode"].text() != initialisationType.getDocumentTypeCode() ) )
                            testRunner.fail("Application Response, Parent Document Type Code incorrect");
                    }
                }
            }
            else
            {
                def blob = it.getBlob ( "MSG_RAWCONTENT" ) ;
                def byte_stream = blob.getBinaryStream();
                if( byte_stream == null )
                {
                    testRunner.fail("Test: Received null stream!");
                }
                else
                {
                    def rootnode = new groovy.util.XmlParser(false,false).parse(byte_stream);
                    if( (msgId != '-1') && ( rootnode["urn:ID"].text() != msgId ) && ( rootnode["urn1:ID"].text() != msgId ) && ( rootnode["cbc:ID"].text() != msgId ) )
                        testRunner.fail("Application Response, ID incorrect");
                    if( ( rootnode["urn:DocumentResponse"]["urn:Response"]["urn1:ResponseCode"].text() != responseCode ) && ( rootnode["urn1:DocumentResponse"]["urn1:Response"]["urn2:ResponseCode"].text() != responseCode ) && ( rootnode["cac:DocumentResponse"]["cac:Response"]["cbc:ResponseCode"].text() != responseCode ) )
                        testRunner.fail("Application Response, Response Code incorrect");
                    if( ( description != null ) && ( rootnode["urn:DocumentResponse"]["urn:Response"]["urn1:Description"].text() != description ) && ( rootnode["urn1:DocumentResponse"]["urn1:Response"]["urn2:Description"].text() != description ) && ( rootnode["cac:DocumentResponse"]["cac:Response"]["cbc:Description"].text() != description )  )
                        testRunner.fail("Application Response, Description incorrect");
                    if( parentId != -1 && checkDocumentReferenceId )
                    {
                        if( ( rootnode["urn:DocumentResponse"]["urn:DocumentReference"]["urn1:ID"].text() != parentId ) && ( rootnode["urn1:DocumentResponse"]["urn1:DocumentReference"]["urn2:ID"].text() != parentId ) && ( rootnode["cac:DocumentResponse"]["cac:DocumentReference"]["cbc:ID"].text() != parentId ) )
                            testRunner.fail("Application Response, Parent ID incorrect");
                        if( ( rootnode["urn:DocumentResponse"]["urn:DocumentReference"]["urn1:DocumentTypeCode"].text() != initialisationType.getDocumentTypeCode() ) && ( rootnode["urn1:DocumentResponse"]["urn1:DocumentReference"]["urn2:DocumentTypeCode"].text() != initialisationType.getDocumentTypeCode() ) && ( rootnode["cac:DocumentResponse"]["cac:DocumentReference"]["cbc:DocumentTypeCode"].text() != initialisationType.getDocumentTypeCode() ) )
                            testRunner.fail("Application Response, Parent Document Type Code incorrect");
                    }
                }
            }
	      numResults++;
        }            
        if(numResults != 1)
        {
            log.error "Number of application response results incorrect " + numResults;
            testRunner.fail("Number of application response results incorrect");
        }
    }
    
    def verifyApplicationResponseValidity( TestEnvironment testEnvironment, String messageName = "Request" )
    {     
        def responseStep = testRunner.testCase.getTestStepByName(messageName);
        def responseResponse = responseStep.getProperty("response");
        def responseNode = new groovy.util.XmlParser(false,false).parseText(responseResponse.value);

        def responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"[0]."p:ApplicationResponse"[0];
	  if( !responseXml )
	  {
	  	responseXml = responseNode."soapenv:Body"."ec:SubmitRetrieveRequestResponse"."ec:RetrieveResponse"."ec1:DocumentContent"[0]."urn:ApplicationResponse"[0];
	  }
        def responseWriter = new StringWriter()
        new XmlNodePrinter(new PrintWriter(responseWriter)).print(responseXml)
        def responseResult = responseWriter.toString()

        try
        {
            def factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI)
            
            def schemaLocation = null;
            
            switch (testEnvironment)
            {
            case TestEnvironment.TEST:
                schemaLocation = new URL("http://epriord.cc.cec.eu.int:17091/eprior/external/Phase2a/RetrieveRequest-0.1?SCHEMA/eprior/xsd/maindoc/UBL-ApplicationResponse-2.0")
                break;
            case TestEnvironment.DEVELOPMENT:
                schemaLocation = new URL("http://epriord.cc.cec.eu.int:7091/eprior/external/Phase2a/RetrieveRequest-0.1?SCHEMA/eprior/xsd/maindoc/UBL-ApplicationResponse-2.0")
                break;
            case TestEnvironment.ACCEPTANCE:
                schemaLocation = new URL("http://epriora.cc.cec.eu.int:7091/eprior/external/Phase2a/RetrieveRequest-0.1?SCHEMA/eprior/xsd/maindoc/UBL-ApplicationResponse-2.0")
                break;
            default:
                log.error "TestEnvironment unknown";        
            }
            
            def schema = factory.newSchema(schemaLocation)
            def validator = schema.newValidator()
            Source source = new StreamSource(new StringReader(responseResult))
            validator.validate(source)
        }
        catch (SAXException ex)
        {
            testRunner.fail("Application Response validation failed");
            log.info ex;
        }
        catch (Exception ex)
        {
            testRunner.fail("Application Response validation failed");
            log.info ex;
        }
    }
}

public enum MessageType
{
        INVOICE ("INVOICE", "INV", "380", MessageDirection.IN), CREDITNOTE ("CREDITNOTE", "CRN", "81", MessageDirection.IN), ATTACHEDDOCUMENT ("ATTACHMENT", "ATT", "916", MessageDirection.IN), ATTACHEDDOCUMENTOUT ("ATTACHMENT", "ATT", "916", MessageDirection.OUT), APPLICATIONRESPONSE ("APPLICATIONRESPONSE", "APR", "301", MessageDirection.OUT), REQUESTFORQUOTATION ("RQI", "RQI", "311", MessageDirection.OUT), WILLINGNESS ("WILLINGNESS", "WIL", "ADT1", MessageDirection.IN), ACKNOWLEDGEMENT ("ACKNOWLEDGEMENT", "ACK", "312", MessageDirection.IN), PROPOSALREQUEST ("PROPOSAL_REQUEST", "PRQ", "ADT2", MessageDirection.OUT), ORDER ("ORDER", "ORD", "220", MessageDirection.OUT), ORDERCANCELLATION ("ORD_CANCELLATION_CANCEL", "ORD", "406", MessageDirection.OUT), CATALOGUE ("CATALOGUE", "CAT", "9", MessageDirection.IN), ADHOCC2S ("ADHOCC2S", "ACS", "ADT6", MessageDirection.OUT), ADHOCS2C ("ADHOCS2C", "ASC", "ADT5", MessageDirection.IN), QUOTATIONREQUEST ("QUOTATION_REQUEST", "QRQ", "ADT4", MessageDirection.OUT), QUOTATION ("QUOTATION", "QUO", "310", MessageDirection.IN), PROPOSAL ("PROPOSAL", "PRO", "ADT3", MessageDirection.IN), ORDERRESPONSESIMPLE ("ORD_ACCEPTED", "ORD", "231", MessageDirection.IN), ORDERRESPONSESIMPLEREJECTED ("ORD_RESPONSE_CANCEL", "ORD", "231", MessageDirection.IN), ORDERCHANGE ("ORD_CHANGE_CANCEL", "ORD", "230", MessageDirection.IN), ORDERACKNOWLEDGEMENT ("ORD_PROCESSED", "ORD", "312", MessageDirection.OUT);
        String name;
        String prefix;
        String documentTypeCode;
        MessageDirection messageDirection;
        MessageType(String name, String prefix, String documentTypeCode, MessageDirection messageDirection)
        {
            this.name = name;
            this.prefix = prefix;
            this.documentTypeCode = documentTypeCode;
            this.messageDirection = messageDirection;
        }
        
        String toString(){name;}
        String getPrefix(){prefix;}
        String getDocumentTypeCode(){documentTypeCode;}
}


public enum MessageState
{
        NON_EXISTING, RECEIVED, PROCESSED, REJECTED, SENT, ACCEPTED;
}

public enum MessageDirection
{
        IN, OUT;
}

public enum TestEnvironment
{
        TEST, DEVELOPMENT, ACCEPTANCE, PROD, OPEN_EPRIOR_TEST, NON_EXISTING;
}

public enum StatusRequestMode
{
        NO_RELATED_DOCUMENTS, SEVERAL_RELATED_DOCUMENTS, APPLICATION_RESPONSE, MAX_ONE_NOT_REJECTED, ONLY_DIRECT_REFERENCE;
}

public enum DatabaseUser
{
        ALL, EANTST0, EAN1, EANCATSUP0;
}

public enum JmsQueues
{
        BO_TO_EPRIOR, EPRIOR_TO_EREQUESTBO;
}